/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.geometries.gui;

import java.util.ArrayList;
import javax.swing.event.ChangeListener;
import org.apache.log4j.Logger;
import org.visnow.jscic.RegularField;
import org.visnow.vn.geometries.objects.SignalingTransform3D;
import org.visnow.vn.geometries.parameters.DataMappingParams;
import org.visnow.vn.geometries.parameters.PresentationParams;
import org.visnow.vn.geometries.parameters.RenderingParams;
import org.visnow.vn.geometries.parameters.TransformParams;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class RegularFieldPresentationGUI extends javax.swing.JPanel
{

    private static final Logger LOGGER = Logger.getLogger(RegularFieldPresentationGUI.class);

    RegularField inField = null;
    private int nScalarComps = 0;
    private int nDims = -1;
    private PresentationParams params = null;

    /**
     * Creates new form ColoringGUI
     */
    public RegularFieldPresentationGUI()
    {
        initComponents();
        dataMappingGUI.setStartNullTransparencyComponent(true);
    }

    public void setInField(RegularField inField)
    {
        if (inField == null)
            return;
        this.inField = inField;
        nScalarComps = 0;
        //active = true;        
        if (!fixFlag && params != null) {
            dataMappingGUI.setInData(inField, params.getDataMappingParams());
            displayPropertiesGUI.setRenderingParams(params.getRenderingParams());
            transformGUI.setTransformParams(params.getTransformParams());
            if (inField.getDims().length == 3)
                displayContentGUI.setParams(params.getContent3DParams());
        }

        if (nDims == -1 || nDims != inField.getDims().length) {
            nDims = inField.getDims().length;
            displayPropertiesGUI.setNDims(nDims);
            displayContentGUI.setVisible(nDims == 3);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        extendedTabbedPane = new javax.swing.JTabbedPane();
        dataMappingScrollPane = new javax.swing.JScrollPane();
        dataMappingPanel = new javax.swing.JPanel();
        dataMappingGUI = new org.visnow.vn.geometries.gui.DataMappingGUI();
        displayPropertiesScrollPane = new javax.swing.JScrollPane();
        displayPropertiesPanel = new javax.swing.JPanel();
        displayPropertiesGUI = new org.visnow.vn.geometries.gui.RenderingGUI();
        displayContentGUI = new org.visnow.vn.geometries.gui.RegularField3DMapPanel();
        transformScrollPane = new javax.swing.JScrollPane();
        transformPanel = new javax.swing.JPanel();
        transformGUI = new org.visnow.vn.geometries.gui.TransformPanel();

        setRequestFocusEnabled(false);
        setLayout(new java.awt.CardLayout());

        extendedTabbedPane.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        extendedTabbedPane.setToolTipText("");

        dataMappingScrollPane.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);

        dataMappingPanel.setLayout(new java.awt.BorderLayout());
        dataMappingPanel.add(dataMappingGUI, java.awt.BorderLayout.NORTH);

        dataMappingScrollPane.setViewportView(dataMappingPanel);

        extendedTabbedPane.addTab("Datamap", dataMappingScrollPane);

        displayPropertiesScrollPane.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);

        displayPropertiesPanel.setLayout(new java.awt.BorderLayout());

        displayPropertiesGUI.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        displayPropertiesPanel.add(displayPropertiesGUI, java.awt.BorderLayout.CENTER);
        displayPropertiesPanel.add(displayContentGUI, java.awt.BorderLayout.NORTH);

        displayPropertiesScrollPane.setViewportView(displayPropertiesPanel);

        extendedTabbedPane.addTab("Display", displayPropertiesScrollPane);

        transformScrollPane.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);

        transformPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(4, 4, 4, 4));
        transformPanel.setLayout(new java.awt.BorderLayout());
        transformPanel.add(transformGUI, java.awt.BorderLayout.NORTH);

        transformScrollPane.setViewportView(transformPanel);

        extendedTabbedPane.addTab("Transform", transformScrollPane);

        add(extendedTabbedPane, "extendedUI");
    }// </editor-fold>//GEN-END:initComponents

    public RegularField3DMapPanel getRegularField3DMapPanel()
    {
        return displayContentGUI;
    }

    /**
     * Utility field holding list of ChangeListeners.
     */
    private transient ArrayList<ChangeListener> changeListenerList = new ArrayList<ChangeListener>();

    /**
     * Registers ChangeListener to receive events.
     *
     * @param listener The listener to register.
     */
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     *
     * @param listener The listener to remove.
     */
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    public void setDisplayParams(RenderingParams displayParams)
    {
        displayPropertiesGUI.setRenderingParams(displayParams);
    }

    public void setTransforParams(TransformParams params)
    {
        transformGUI.setTransformParams(params);
    }

    public void setParams(PresentationParams params)
    {
        this.params = params;
        if (inField != null && params != null) {
            dataMappingGUI.setInData(inField, params.getDataMappingParams());
            displayPropertiesGUI.setRenderingParams(params.getRenderingParams());
            transformGUI.setTransformParams(params.getTransformParams());
            if (inField.getDims().length == 3) {
                displayContentGUI.setParams(params.getContent3DParams());
            }
        }
    }

    private boolean fixFlag = false;

    public void setInData(RegularField inField, PresentationParams params)
    {
        if (inField == null || params == null) {
            return;
        }
        setParams(params);
        setInField(inField);
    }

    public void setSignalingTransform(SignalingTransform3D sigTrans)
    {
        transformGUI.setSigTrans(sigTrans);
    }

    public void setTransSensitivity(float s)
    {
        transformGUI.setTransSensitivity(s);
    }

    public RenderingParams getRenderingParams()
    {
        return params.getRenderingParams();
    }

    public DataMappingParams getMappingParams()
    {
        return params.getDataMappingParams();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.geometries.gui.DataMappingGUI dataMappingGUI;
    private javax.swing.JPanel dataMappingPanel;
    private javax.swing.JScrollPane dataMappingScrollPane;
    private org.visnow.vn.geometries.gui.RegularField3DMapPanel displayContentGUI;
    private org.visnow.vn.geometries.gui.RenderingGUI displayPropertiesGUI;
    private javax.swing.JPanel displayPropertiesPanel;
    private javax.swing.JScrollPane displayPropertiesScrollPane;
    private javax.swing.JTabbedPane extendedTabbedPane;
    private org.visnow.vn.geometries.gui.TransformPanel transformGUI;
    private javax.swing.JPanel transformPanel;
    private javax.swing.JScrollPane transformScrollPane;
    // End of variables declaration//GEN-END:variables
    /**
     * @return the dataMappingGUI
     */
    public org.visnow.vn.geometries.gui.DataMappingGUI getDataMappingGUI()
    {
        return dataMappingGUI;
    }

}
